import os
from pathlib import Path

import click
from click.exceptions import ClickException
from .stream import play, Stream, local
from .dates import quarter_year
from .save import yt


@click.group()
def cli():
    pass


@cli.command("stream")
@click.argument(
    "stream", type=click.Choice([e.value for e in Stream]), default=Stream.KEXP
)
def _stream(stream):
    """play streams."""
    play(stream)


@cli.command("random")
def _random():
    """play randomly from local music."""
    local()


@cli.command("yt")
@click.argument("url", required=True)
def _save(url):
    """
    download a youtube song from URL to current quarter dir.

    URL: youtube url to download
    """
    yt(url)


if __name__ == "__main__":
    cli()
