from pathlib import Path
from typing import Generator

from music.dates import quarter_year


def seasons() -> Generator[Path, None, None]:
    prefix = ("fall_", "winter_", "spring_", "summer_")
    music_dir = Path().home() / "Music"
    for d in music_dir.iterdir():
        if not d.is_dir():
            continue
        if not d.name.startswith(prefix):
            continue
        yield d
    yield from []


def current_quarter() -> Path:
    quarter, year = quarter_year()
    return Path().home() / "Music" / f"{quarter}_{year}"
