from mutagen.easyid3 import EasyID3
import yt_dlp
from .dates import quarter_year
from .paths import current_quarter
import os

from pathlib import Path


def yt(url):
    ydl_opts = {
        "format": "mp3/bestaudio/best",
        # ℹ️ See help(yt_dlp.postprocessor) for a list of available Postprocessors and their arguments
        "postprocessors": [
            {  # Extract audio using ffmpeg
                "key": "FFmpegExtractAudio",
                "preferredcodec": "mp3",
            }
        ],
    }

    os.chdir(Path.home() / "Downloads")
    # Download the audio and get the filename
    with yt_dlp.YoutubeDL(ydl_opts) as ydl:
        info_dict = ydl.extract_info(url, download=True)
        _ = ydl.prepare_filename(info_dict)
    if info_dict is None:
        raise ValueError("error downloading")
    filename = info_dict["requested_downloads"][0]["filepath"]

    track = info_dict.get("track")
    artist = info_dict.get("artist")

    parent = current_quarter()
    if not parent.exists():
        parent.mkdir(parents=True)
    if track is not None and artist is not None:
        name = f"{artist} - {track}.mp3"
        new_filepath = parent / name
        os.rename(filename, new_filepath)
        tags = EasyID3(new_filepath)
        tags["title"] = track
        tags["artist"] = artist
        tags.save()

    else:
        new_filepath = parent / filename
        os.rename(filename, new_filepath)
